/**
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
package uk.ac.leeds.ccg.andyt.generic.memory;

/**
 * A class with methods that help in testing computer memory.
 */
public class Generic_TestMemory {

    protected transient Runtime _Runtime;

    /** Creates a new instance of Generic_TestMemory */
    public Generic_TestMemory() {
        init_Runtime();
    }

    /**
     * Initialises _Runtime if it has not been.
     */
    public Runtime get_Runtime() {
        if (_Runtime == null) {
            this._Runtime = Runtime.getRuntime();
        }
        return _Runtime;
    }

    /**
     * Initialises _Runtime
     */
    protected final void init_Runtime() {
        this._Runtime = Runtime.getRuntime();
    }

    /**
     * For returning the total free memory.
     * @return The TotalFreeMemory available as calculated from _Runtime.
     */
    public long getTotalFreeMemory() {
        long result;
        Runtime a_Runtime = get_Runtime();
        long maxMemory = a_Runtime.maxMemory();
        long allocatedMemory = a_Runtime.totalMemory();
        long freeMemory = a_Runtime.freeMemory();
        result = freeMemory + (maxMemory - allocatedMemory);
        return result;
    }
}
